/*
 * CSet.cpp
 *
 *  Created on: Feb 22, 2009
 *      Author: qwan
 */

#include "CSet.h"

void CSet::setDimeLen(int* dl) {
	dimLen = dl;
}

int CSet::mapping(int *vector) {
	int index = 0;
	for (int i = 0; i < dim; i++) {
		index += vector[i] * accDimCount[i];
	}
	return index;
}

void CSet::setBit(int index, bool val) {
	int h = index / 8;
	int d = index % 8;

	if (val) {
		ptr[h] = ptr[h] | msk_array[d];
	} else {
		ptr[h] = ptr[h] ^ (ptr[h] & msk_array[d]);
	}

}

int* CSet::remapping(int index) {

	int* vector = new int[dim];
	for (int i = 0; i < dim; i++) {
		vector[dim - i - 1] = index / accDimCount[i];
		index = index % accDimCount[i];
	}

	return vector;
}

bool CSet::check(int index) {

	if (index >= full) {
		return false;
	}

	int h = index / 8;
	int d = index % 8;

	if ((ptr[h] & msk_array[d]) == 0) {
		return false;
	}

	return true;
}

int* CSet::next() {
	if (!check(curr)) {
		return remapping(curr++);
	} else {
		curr++;
		return NULL;
	}

}
;

bool CSet::isoverflow() {

	if (curr < 0) {
		printf("got you!!!!!!!!!!!!!!!");
	}

	if (curr >= full) {
		return true;
	}

	return false;
}

void CSet::print() {
	printf("%d", dim);
	printf("%d", curr);

	printf("\n");

	for (int i = 0; i < dim; i++) {
		printf("%d ", accDimCount[i]);
	}

	printf("\n");

	for (int i = 0; i < dim; i++) {
		printf("%d ", dimLen[i]);
	}
	printf("\n");

	for (int i = 0; i < 8; i++) {
		printf("%d ", msk_array[i]);
	}
	printf("\n");

}
