#include "util.h"

int load_file() {

	created = new PtsSpace;
	exsiting = new PtsSpace;

	bool created_bnl = false;
	bool existing_bnl = false;

	FILE* pFile;

	if ((pFile = fopen("data/new_table.txt", "r")) == NULL) {
		printf("reading error!!!");
		return 0;
	}

	int tuple, dim;

	int status = fscanf(pFile, "%d %d", &tuple, &dim);

	if (status <= 0 || status == EOF){
		printf("read data error \n");
	}

	domain = new set<int> [dim];

	created->init(dim, tuple, dim - 1);

	for (int i = 0; i < created->tupleNum; i++) {
		for (int j = 0; j < created->dimNum; j++) {
			fscanf(pFile, "%d", &(created->v[i][j]));
			domain[j].insert(created->v[i][j]);
			if (j == created->dimNum - 1) {
				created->v[i][j] = ceil(setting.d * created->v[i][j]);
			}
		}
	}

	fclose(pFile);

	if ((pFile = fopen("data/exsiting_table.txt", "r")) == NULL) {
		printf("reading error!!!");
		//exit(0);
		return 0;
	}

	status = fscanf(pFile, "%d %d", &tuple, &dim);

	if (status <= 0 || status == EOF){
		printf("read data error \n");
	}

	exsiting->init(dim, tuple, dim - 1);

	for (int i = 0; i < exsiting->tupleNum; i++) {
		for (int j = 0; j < exsiting->dimNum; j++) {
			fscanf(pFile, "%d", &(exsiting->v[i][j]));
		}
	}

	fclose(pFile);

	if (created_bnl) {
		created->bnl();
	}

	if (existing_bnl) {
		exsiting->bnl();
	}

	created->reverseSort(0);

	created->build_index();
	exsiting->build_index();

	if (created_bnl) {
		created->tofile("created.txt");
	}

	if (existing_bnl) {
		exsiting->tofile("exsiting.txt");
	}

	list_delta_dom = new int[created->tupleNum];
	list_delta_comp = new int[created->tupleNum];
	list_delta_dom2 = new int[created->tupleNum];
	list_delta_comp2 = new int[created->tupleNum];

	memset(list_delta_comp, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_dom, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_comp2, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);
	memset(list_delta_dom2, _LIST_UNDEFINED, sizeof(int) * created->tupleNum);

	return 0;
}
;

int price_dom(int q) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	//check +inf
	if (setting.h == 0) {
		return _MAX;
	}

	counter_total++;

	//check cache
	if (list_delta_dom[q] != _LIST_UNDEFINED) {

		if (list_delta_dom[q] >= _MAX) {
			counter_inf_hit++;
		} else if (list_delta_dom[q] <= -_MAX) {
			counter_ninf_hit++;
		}

		return list_delta_dom[q];
	}

	//calculate value of delta_dom

	counter_dom1++;

	int min = _MAX;
	//delta_dom
	if (setting.h > 0) {
		int* v1 = created->v[q];
		int* v2 = new int[created->dimNum];

		for (int i = 0; i < created->dimNum; i++) {
			v2[i] = _MAX;
		}

		Pt_Collection* pcp = exsiting->rect_query(v1, v2);

		if (pcp->size() >= setting.h) {
			PtsSpace* pt = exsiting->Product(pcp);
			pt->sort(pt->dimNum - 1);
			if (min > pt->v[setting.h - 1][pt->dimNum - 1]) {
				min = pt->v[setting.h - 1][pt->dimNum - 1];
			}
			delete pt;
		} else {
			delete pcp;
			delete[] v2;
			list_delta_dom[q] = -_MAX;
			counter_ninf_hit++;
			return -_MAX;
		}

		delete pcp;
		delete[] v2;
	}

	list_delta_dom[q] = min;

	if (min >= _MAX) {
		counter_inf_hit++;
	} else if (min <= -_MAX) {
		counter_ninf_hit++;
	}

	return min;
}

int price_comp(int q) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	counter_total++;

	if (list_delta_comp[q] != 0) {
		if (list_delta_comp[q] >= _MAX) {
			counter_inf_hit++;
		}
		return list_delta_comp[q];
	}

	counter_comp1++;

	int min = _MAX;

	int* v1 = new int[exsiting->dimNum - 1];
	memset(v1, 0, sizeof(int) * (exsiting->dimNum - 1));

	Pt_Collection* pcp = exsiting->rect_query(v1, created->v[q]);

	if (pcp->size() == 0) {
		delete pcp;
		delete[] v1;
		counter_inf_hit++;
		return _MAX;
	}

	PtsSpace* pt2 = exsiting->Product(pcp);

	pt2->calM();

	if (min > pt2->min[created->dimNum - 1]) {
		min = pt2->min[created->dimNum - 1];
	}

	delete[] v1;
	delete pt2;
	delete pcp;
	//	return min - setting.sigma - created->v[q][created->dimNum-1];

	list_delta_comp[q] = min;

	return min;
}

int price_dom(int q, PtsSpace* local_created) {
	/*
	 * return -_MAX if -inf
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	if (setting.h == 0) {
		return _MAX;
	}

	counter_dom2++;

	Pt_Collection* tpc = created->rect_query(local_created->v[q],
			local_created->v[q]);
	Pt_Collection::iterator tpc_iter = tpc->begin();

	if (list_delta_dom2[*tpc_iter] != 0) {
		int re = list_delta_dom2[*tpc_iter];
		delete tpc;
		return re;
	}

	int min = _MAX;

	//delta_dom
	if (setting.h > 0) {
		int* v1 = local_created->v[q];
		int* v2 = new int[local_created->dimNum];

		for (int i = 0; i < local_created->dimNum; i++) {
			v2[i] = _MAX;
		}

		Pt_Collection* pcp = exsiting->rect_query(v1, v2);

		if (pcp->size() >= setting.h) {
			PtsSpace* pt = exsiting->Product(pcp);
			pt->sort(pt->dimNum - 1);
			if (min > pt->v[setting.h - 1][pt->dimNum - 1]) {
				min = pt->v[setting.h - 1][pt->dimNum - 1];
			}
			delete pt;
		} else {
			min = -1;
		}

		delete pcp;
		delete[] v2;

	}

	if (min == -1) {
		delete tpc;
		return -_MAX;
	}

	list_delta_dom2[*tpc_iter] = min;
	delete tpc;

	return min;
}

int price_comp(int q, PtsSpace* local_created) {
	/*
	 * return _MAX if +inf
	 * return min otherwise
	 * */

	counter_comp2++;

	Pt_Collection* tpc = created->rect_query(local_created->v[q],
			local_created->v[q]);
	Pt_Collection::iterator tpc_iter = tpc->begin();

	if (list_delta_comp2[*tpc_iter] != 0) {
		int re = list_delta_comp2[*tpc_iter];
		delete tpc;
		return re;
	}

	int min = _MAX;

	int* v1 = new int[exsiting->dimNum - 1];
	memset(v1, 0, sizeof(int) * (exsiting->dimNum - 1));

	Pt_Collection* pcp = exsiting->rect_query(v1, local_created->v[q]);

	if (pcp->size() == 0) {
		delete pcp;
		delete[] v1;
		delete tpc;
		return _MAX;
	}

	PtsSpace* pt2 = exsiting->Product(pcp);

	pt2->calM();

	if (min > pt2->min[local_created->dimNum - 1]) {
		min = pt2->min[local_created->dimNum - 1];
	}

	delete[] v1;
	delete pt2;
	delete pcp;

	list_delta_comp2[*tpc_iter] = min;

	delete tpc;

	return min;
}

int price_con(int q, Pt_Collection* pc) {

	counter_con++;

	if (pc->empty()) {
		printf("error");
	}

	//pc cannot be empty
	PtsSpace* pt = created->Product(pc);
	pt->sort(0);

	for (int m = pt->tupleNum - 1; m >= 0; m--) {

		int min = _MAX;
		int pdom = price_dom(m, pt);
		int pcom = price_comp(m, pt);

		if (pdom > pcom) {
			min = pcom;
		} else {
			min = pdom;
		}

		//pricing(m, pt);
		if (m != pt->tupleNum - 1) {
			for (int n = m + 1; n < pt->tupleNum; n++) {
				int* v1 = pt->v[n];
				int* v2 = pt->v[m];
				if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
					if (min > pt->v[n][pt->dimNum - 1]) {
						min = pt->v[n][pt->dimNum - 1];
					}
				}
			}
		}

		pt->v[m][pt->dimNum - 1] = min - setting.sigma;
	}

	int min = _MAX;

	for (int n = 0; n < pt->tupleNum; n++) {
		int* v1 = pt->v[n];
		int* v2 = created->v[q];
		if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
			if (min > pt->v[n][pt->dimNum - 1]) {
				min = pt->v[n][pt->dimNum - 1];
			}
		}
	}

	delete pt;

	return min;
}

int delta(int q) {

	counter_del1++;

	int pdom = price_dom(q);
	int pcom = price_comp(q);

	int re = 0;

	if (pdom > pcom) {
		re = pcom;
	} else {
		re = pdom;
	}

	return re - created->v[q][created->dimNum - 1] - setting.sigma;

}

int delta(int q, Pt_Collection* pc) {

	counter_del2++;

	if (pc->empty()) {
		return delta(q);
	}

	int pdom = price_dom(q);
	int pcom = price_comp(q);
	int pconf = price_con(q, pc);

	int re = 0;

	if (pdom < pcom) {
		if (pdom < pconf) {
			re = pdom;
		} else {
			re = pconf;
		}
	} else {
		if (pcom < pconf) {
			re = pcom;
		} else {
			re = pconf;
		}
	}

	if (re == -_MAX) {

	} else if (re == _MAX) {

	}

	return re - created->v[q][created->dimNum - 1] - setting.sigma;

}

bool init(const vector<set<int>::iterator>& s, int t, int* q) {

	int* v = new int[s.size()];
	int* v2 = new int[s.size()];

	for (unsigned int i = 0; i < s.size(); i++) {
		v[i] = *(s[i]);
		v2[i] = 0;
	}

	Pt_Collection* ps = created->rect_query(v2, v);

	delete[] v;
	delete[] v2;

	if (ps->size() > 0) {

		int max = -_MAX, index = 0;

		for (Pt_Collection::iterator i = ps->begin(); i != ps->end(); i++) {
			int del = delta(*i);
			if (del > max) {
				max = del;
				index = *i;
			}
		}

		*q = index;
		delete ps;
		return true;
	}
	delete ps;
	return false;
}


/*
calculate profit for pc
*/
int cal_profit(Pt_Collection* pc) {

	PtsSpace* pt = created->Product(pc);

	//pt->show();

	pt->sort(0);
	int sum = 0;

	for (int m = pt->tupleNum - 1; m >= 0; m--) {

		int min = _MAX;
		int pdom = price_dom(m, pt);
		int pcom = price_comp(m, pt);

		if (pdom > pcom) {
			min = pcom;
		} else {
			min = pdom;
		}

		if (min == -_MAX) {
			delete pt;
			return min;
		}

		//pricing(m, pt);
		if (m != pt->tupleNum - 1) {
			for (int n = m + 1; n < pt->tupleNum; n++) {
				int* v1 = pt->v[n];
				int* v2 = pt->v[m];
				if (pt->dominate(v1, v2, pt->dimNum - 1) == 1) {
					if (min > pt->v[n][pt->dimNum - 1]) {
						min = pt->v[n][pt->dimNum - 1];
					}
				}
			}
		}

		int tp = pt->v[m][pt->dimNum - 1];
		pt->v[m][pt->dimNum - 1] = min - setting.sigma;
		sum += min - setting.sigma - tp;
	}

	delete pt;
	return sum;

}

void release_all(){
	delete created;
	delete exsiting;
	delete[] list_delta_comp;
	delete[] list_delta_comp2;
	delete[] list_delta_dom;
	delete[] list_delta_dom2;

}


void timetofile(struct timespec stop, struct timespec start, FILE * f) {
	double accum = (stop.tv_sec - start.tv_sec) + (double) (stop.tv_nsec
			- start.tv_nsec) / (double) BILLION;
	fprintf(f, "\n%lf", accum);
}

void calculateExecutionTime(struct rusage *myTimeStart,
		struct rusage *myTimeEnd, float *userTime, float *sysTime) {
	(*userTime) = ((float) (myTimeEnd->ru_utime.tv_sec
			- myTimeStart->ru_utime.tv_sec))
			+ ((float) (myTimeEnd->ru_utime.tv_usec
					- myTimeStart->ru_utime.tv_usec)) * 1e-6;
	(*sysTime) = ((float) (myTimeEnd->ru_stime.tv_sec
			- myTimeStart->ru_stime.tv_sec))
			+ ((float) (myTimeEnd->ru_stime.tv_usec
					- myTimeStart->ru_stime.tv_usec)) * 1e-6;

}

void printTimeFile() {

	FILE *filePtr;
	//	char *filename = "time";

	filePtr = (FILE *) fopen("time", "w");
	if (filePtr == NULL) {
		printf("File cannot be opened in printTime!\n");
		exit(0);
	}

	// output execution time

	calculateExecutionTime(&myTime_program_start, &myTime_prep_end, &userTime_prep,
			&sysTime_prep);
	calculateExecutionTime(&myTime_prep_end, &myTime_algo1_end, &userTime_algo1,
			&sysTime_algo1);
	calculateExecutionTime(&myTime_algo1_end, &myTime_algo2_end, &userTime_algo2,
			&sysTime_algo2);
	calculateExecutionTime(&myTime_algo2_end, &myTime_algo3_end, &userTime_algo3,
				&sysTime_algo3);
	calculateExecutionTime(&myTime_algo3_end, &myTime_algo4_end, &userTime_algo4,
				&sysTime_algo4);
//	calculateExecutionTime(&myTime_algo4_end, &myTime_algo5_end, &userTime_algo5,
//				&sysTime_algo5);

	// sorting time
	fprintf(filePtr, "%.10f %.10f\n", userTime_prep, sysTime_prep);

	// writing time
	fprintf(filePtr, "%.10f %.10f\n", userTime_algo1, sysTime_algo1);

	fprintf(filePtr, "%.10f %.10f\n", userTime_algo2, sysTime_algo2);

		// overall time
	fprintf(filePtr, "%.10f %.10f\n", userTime_algo3, sysTime_algo3);

	fprintf(filePtr, "%.10f %.10f\n", userTime_algo4, sysTime_algo4);
//	fprintf(filePtr, "%.10f %.10f\n", userTime_algo5, sysTime_algo5);

	fclose(filePtr);
}

void reInitCounter() {
	counter_dom1 = 0;
	counter_dom2 = 0;
	counter_comp1 = 0;
	counter_comp2 = 0;
	counter_con = 0;
	counter_del1 = 0;
	counter_del2 = 0;
	counter_inf_hit = 0;
	counter_ninf_hit = 0;
	counter_total = 0;
}

void OutputCounter(char* name) {

	FILE *filePtr;

	filePtr = (FILE *) fopen(name, "w");

	fprintf(filePtr, "%ld %ld %ld %f %f", counter_total, counter_inf_hit,
			counter_ninf_hit, (1.0) * counter_inf_hit / counter_total, (1.0)
					* counter_ninf_hit / counter_total);

	fclose(filePtr);

}

int round() {

	int max = 0;
	Pt_Collection s;

	do {

		s.clear();

		for (int i = 0; i < created->tupleNum; i++) {
			int d = delta(i, &s);
			if (d > max) {
				if (rand() % 2) {
					max = d;
					s.insert(i);
				}
			}

			if (s.size() == setting.k) {
				break;
			}
		}

	} while (s.size() < setting.k);

	return cal_profit(&s);

}
